classification
Title: Broken pipes should be handled better in 2.x
Type: enhancement Stage:
Components: Interpreter Core Versions: Python 2.6, Python 2.5
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: alexandre.vassalotti, gvanrossum, naufraghi
Priority: normal Keywords:

Created on 2007-12-11 22:02 by alexandre.vassalotti, last changed 2010-07-09 03:43 by terry.reedy. This issue is now closed.

Messages (2)
msg58469 - (view) Author: Alexandre Vassalotti (alexandre.vassalotti) * (Python committer) Date: 2007-12-11 22:02
I think Python 2.x should mimic, or improve on, the behavior of Py3k for
handling broken pipes. That is:
  1. Don't print the message "close failed: [Errno 32] Broken pipe",
from filemodule.c; since this is impossible to override from Python.
  2. Check sys.stdout if it's closed before calling the print routine.
Raise an IOError if so.

Finally, here's some examples to illustrate what I am saying:

alex:~% python -c "print" | head -n0
close failed: [Errno 32] Broken pipe

alex:~% python -c "while 1: print" | head -n0
[The loop continues running, even if the output stream is closed]
^C
Traceback (most recent call last):
  File "<string>", line 1, in <module>
KeyboardInterrupt
close failed: [Errno 32] Broken pipe

alex:~% py3k -c "print()" | head -n0
alex:~% py3k -c "while 1: print()" | head -n0
Traceback (most recent call last):
 ...
IOError: [Errno 32] Broken pipe
msg58470 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2007-12-11 22:06
I'll entertain a patch for 2.6.

For 2.5 I think this smells too much like a feature.
History
Date User Action Args
2010-07-09 03:43:21terry.reedysetstatus: open -> closed
resolution: out of date
2009-10-24 16:19:20naufraghisetnosy: + naufraghi
2008-03-18 00:36:41jafosetpriority: normal
2007-12-11 22:06:29gvanrossumsetnosy: + gvanrossum
messages: + msg58470
2007-12-11 22:02:26alexandre.vassalotticreate